using System;
using System.Text;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using System.Security.Policy;
using System.Security.Principal;
using System.Security.Permissions;
using System.Threading;

namespace SecurityIx
{
	/// <summary>
	/// Zusammendfassende Beschreibung fr Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.RichTextBox Ausgabe;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.Ausgabe = new System.Windows.Forms.RichTextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// Ausgabe
			// 
			this.Ausgabe.Location = new System.Drawing.Point(16, 16);
			this.Ausgabe.Name = "Ausgabe";
			this.Ausgabe.Size = new System.Drawing.Size(416, 232);
			this.Ausgabe.TabIndex = 0;
			this.Ausgabe.Text = "";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(448, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(128, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Evidence Test";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(448, 224);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(128, 23);
			this.button2.TabIndex = 2;
			this.button2.Text = "Beenden";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(448, 48);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(128, 24);
			this.button3.TabIndex = 3;
			this.button3.Text = "GenericRoles";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(448, 80);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(128, 24);
			this.button4.TabIndex = 4;
			this.button4.Text = "Windows Roles";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button4,
																		  this.button3,
																		  this.button2,
																		  this.button1,
																		  this.Ausgabe});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			Application.Exit ();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			StringBuilder sb = new StringBuilder ();
			Type t = Type.GetType("System.String");
			Assembly a = Assembly.GetAssembly (t);
			Evidence ev = a.Evidence;
			IEnumerator i = ev.GetEnumerator ();
			while (i.MoveNext ())
			{
				sb.Append (i.Current);
				sb.Append (Environment.NewLine);
			}
			Ausgabe.Text = sb.ToString ();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			string nl = Environment.NewLine;
			StringBuilder sb = new StringBuilder ();
			string[] roles = {"Autor", "Editor", "Lektor"};
			GenericIdentity i = new GenericIdentity("Krause");
			GenericPrincipal p = new GenericPrincipal(i, roles);
			Thread.CurrentPrincipal = p;
			sb.Append ("Angaben fr: " + Thread.CurrentPrincipal.Identity.Name);
			sb.Append (Environment.NewLine);
			sb.Append ("Authentifizierungstyp: " + Thread.CurrentPrincipal.Identity.AuthenticationType.ToString());
			sb.Append (Environment.NewLine);
			sb.Append ("Ist Authentizifiert: " + Thread.CurrentPrincipal.Identity.IsAuthenticated.ToString());
			sb.Append (Environment.NewLine);
			if (Thread.CurrentPrincipal.IsInRole("Autor"))
				sb.Append ("Krause hat die Rolle Autor" + nl);
			if (Thread.CurrentPrincipal.IsInRole("Chef"))
				sb.Append ("Krause hat die Rolle Chef" + nl);
			if (Thread.CurrentPrincipal.IsInRole("Lektor"))
				sb.Append ("Krause hat die Rolle Lektor" + nl);
			Ausgabe.Text = sb.ToString ();
		}

		[PrincipalPermission(SecurityAction.Demand, Name=@"W2KWS\joerglocal")]
		public static string UserAction ()
		{
			return ("User Action gerufen");
		}

		[PrincipalPermission(SecurityAction.Demand, Name=@"W2KWS\Administrator")]
		public static string AdminAction ()
		{
			return ("Admin Action gerufen");
		}
		
		private void button4_Click(object sender, System.EventArgs e)
		{
			Ausgabe.Clear();
			AppDomain.CurrentDomain.SetPrincipalPolicy(PrincipalPolicy.WindowsPrincipal);
			Ausgabe.Text += "Konto: " + Thread.CurrentPrincipal.Identity.Name;
			Ausgabe.Text += Environment.NewLine;
			try
			{
				Ausgabe.Text += "Versuche UserAction()" + Environment.NewLine;
				Ausgabe.Text += UserAction() + Environment.NewLine;
				Ausgabe.Text += "Versuche AdminAction()" + Environment.NewLine;
				Ausgabe.Text += AdminAction() + Environment.NewLine;
			}
			catch (Exception ex)
			{
				Ausgabe.Text += "Ausnahme: " + ex.Source + ", " + ex.Message;
			}
		}
	}
}
